SystemOrganization addCategory: #'ObjectDiff-Sheet'!
SystemOrganization addCategory: #'ObjectDiff-Sheet-Test'!
SystemOrganization addCategory: #'ObjectDiff-Sheet-GUI'!
SystemOrganization addCategory: #'ObjectDiff-System'!
SystemOrganization addCategory: #'ObjectDiff-Test'!
SystemOrganization addCategory: #'ObjectDiff-GUI'!
SystemOrganization addCategory: #ObjectDiff!

!Set methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 23:10'!
objectDiffKeys
^self isEmpty
	ifTrue: [Array new]
	ifFalse: [1 to: self size]! !

!Set methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:32'!
objectDiffValueAt: anInteger 
^self asArray at: anInteger ! !

!Dictionary methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 23:08'!
objectDiffKeys
^self keys! !

!Dictionary methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:22'!
objectDiffValueAt: anObject
^self at: anObject! !

!Array methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/28/2012 14:15'!
literalForm
^self collect: #literalForm! !

!Interval methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 12/27/2012 13:34'!
isCollectionToObjectDiff
	^false! !

!Interval methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 12/27/2012 13:28'!
objectDiffKeys
	^{'start'. 'stop'. 'step'}! !

!Interval methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 12/27/2012 13:30'!
objectDiffValueAt: aString 
	aString = 'start' ifTrue: [^start].
	aString = 'stop' ifTrue: [^stop].
	aString = 'step' ifTrue: [^step].
	self error: 'what ?'! !

TestCase subclass: #DiffOnlyDiffSheetTest
	instanceVariableNames: 's'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

DiffOnlyDiffSheetTest subclass: #DiffOnlyDSEqualPointsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DiffOnlyDSEqualPointsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 18:42'!
setUp
super setUp.
s leftSideObject: 2@3.
s rightSideObject: 2@3.
! !

!DiffOnlyDSEqualPointsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifference
self deny: (s canOpenInnerDifferenceAtKey: 'x').
self deny: (s canOpenInnerDifferenceAtKey: 'y').! !

!DiffOnlyDSEqualPointsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DiffOnlyDSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DiffOnlyDSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DiffOnlyDSEqualPointsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:07'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#equal 'object' '(2@3)' '(2@3)'))! !

!DiffOnlyDSEqualPointsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DiffOnlyDSEqualPointsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #equal! !

!DiffOnlyDSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: (2 @ 3)! !

!DiffOnlyDSEqualPointsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:42'!
testListRowSize
self assert: s listRowSize equals: 1! !

!DiffOnlyDSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: (2 @ 3)! !

DiffOnlyDiffSheetTest subclass: #DiffOnlyDSIdenticalIntegersTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DiffOnlyDSIdenticalIntegersTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 18:42'!
setUp
super setUp.
s leftSideObject: 37.
s rightSideObject: 37.
! !

!DiffOnlyDSIdenticalIntegersTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifference
self deny: (s canOpenInnerDifferenceAtKey: 'foo').
! !

!DiffOnlyDSIdenticalIntegersTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DiffOnlyDSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DiffOnlyDSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DiffOnlyDSIdenticalIntegersTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:15'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: #(#(#identical 'object' '37' '37')).! !

!DiffOnlyDSIdenticalIntegersTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DiffOnlyDSIdenticalIntegersTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #identical! !

!DiffOnlyDSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: 37! !

!DiffOnlyDSIdenticalIntegersTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:42'!
testListRowSize
self assert: s listRowSize equals: 1! !

!DiffOnlyDSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: 37! !

DiffOnlyDiffSheetTest subclass: #DiffOnlyDSLeftShortStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DiffOnlyDSLeftShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 18:42'!
setUp
super setUp.
s leftSideObject: 'hell'.
s rightSideObject: 'hello'.
! !

!DiffOnlyDSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 12/27/2012 12:21'!
testCanOpenInnerDifference
self assert: s canOpenInnerDifferenceLiteralForm equals:
#(
	#('object' false) 
	#('size' false) 
	#('5' false))! !

!DiffOnlyDSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/27/2012 12:17'!
testCanOpenInspector
	self assert: (s canOpenInspectorLiteralForm) equals: 
#(
	#('object' true true) 
	#('size' true true) 
	#('5' false true))! !

!DiffOnlyDSLeftShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:21'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#different 'object' '''hell''' '''hello''') 
	#(#different 'size' '4' '5') 
	#(#leftMissing '5' '' '$o'))! !

!DiffOnlyDSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/27/2012 12:20'!
testObjectsLiteralForm
	self assert: (s objectsLiteralForm) equals:
#(
	#('object' 'hell' 'hello') 
	#('size' 4 5) 
	#('5' nil $o))! !

DiffOnlyDiffSheetTest subclass: #DiffOnlyDSRectanglePointTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DiffOnlyDSRectanglePointTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 18:42'!
setUp
super setUp.
s leftSideObject: (10@5 corner: 20@20).
s rightSideObject: (7@7).
! !

!DiffOnlyDSRectanglePointTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 18:42'!
testBalloonText
self assert: (s listItemAtRow: 4) balloonText equals: 
'x:
	
	7'! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifferenceAtKeyIndex2
self assert: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifferenceAtKeyIndex3
self deny: (s canOpenInnerDifferenceAtKeyIndex: 3)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifferenceAtKeyIndex4
self deny: (s canOpenInnerDifferenceAtKeyIndex: 4)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifferenceAtKeyIndex5
self deny: (s canOpenInnerDifferenceAtKeyIndex: 5)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifferenceAtKeyIndex6
self deny: (s canOpenInnerDifferenceAtKeyIndex: 6)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorLeft2
self assert: (s canOpenLeftInspectorAtRowIndex: 2)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorLeft3
self assert: (s canOpenLeftInspectorAtRowIndex: 3)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorLeft4
self deny: (s canOpenLeftInspectorAtRowIndex: 4)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorLeft5
self deny: (s canOpenLeftInspectorAtRowIndex: 5)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorLeft6
self assert: (s canOpenLeftInspectorAtRowIndex: 6)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorRight2
self assert: (s canOpenRightInspectorAtRowIndex: 2)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorRight3
self deny: (s canOpenRightInspectorAtRowIndex: 3)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorRight4
self assert: (s canOpenRightInspectorAtRowIndex: 4)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorRight5
self assert: (s canOpenRightInspectorAtRowIndex: 5)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorRight6
self deny: (s canOpenRightInspectorAtRowIndex: 6)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:11'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#different 'object' '(10@5) corner: (20@20)' '(7@7)') 
	#(#different 'class' 'Rectangle' 'Point') 
	#(#rightMissing 'origin' '(10@5)' '') 
	#(#leftMissing 'x' '' '7') 
	#(#leftMissing 'y' '' '7') 
	#(#rightMissing 'corner' '(20@20)' ''))! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow2
self assert: (s diffKeyAtRow: 2) equals: 'class'! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow3
self assert: (s diffKeyAtRow: 3) equals: 'origin'! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow4
self assert: (s diffKeyAtRow: 4) equals: 'x'! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow5
self assert: (s diffKeyAtRow: 5) equals: 'y'! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow6
self assert: (s diffKeyAtRow: 6) equals: 'corner'! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #different! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow2
self assert: (s diffTypeAtRow: 2) equals: #different! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow3
self assert: (s diffTypeAtRow: 3) equals: #rightMissing! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow4
self assert: (s diffTypeAtRow: 4) equals: #leftMissing! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow5
self assert: (s diffTypeAtRow: 5) equals: #leftMissing! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow6
self assert: (s diffTypeAtRow: 6) equals: #rightMissing! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: (10@5 corner: 20@20)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: Rectangle! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testLeftSideObjectOfListItemAtRow3
self assert: (s leftSideObjectOfListItemAtRow: 3) equals: (10@5)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testLeftSideObjectOfListItemAtRow6
self assert: (s leftSideObjectOfListItemAtRow: 6) equals: (20@20)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:42'!
testListItemOfLeftSideAtRow4
self assert: (s itemStringOfLeftSideAtRow: 4) equals: ''! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:42'!
testListItemOfLeftSideAtRow5
self assert: (s itemStringOfLeftSideAtRow: 5) equals: ''! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:42'!
testListItemOfRightSideAtRow3
self assert: (s itemStringOfRightSideAtRow: 3) equals: ''! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:42'!
testListItemOfRightSideAtRow6
self assert: (s itemStringOfRightSideAtRow: 6) equals: ''! !

!DiffOnlyDSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:42'!
testListRowSize
self assert: s listRowSize equals: 6! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testOpenInnerDifferenceAtKeyIndex2
| in |
in := (s openInnerDifferenceAtKeyIndex: 2).
self assert: in leftSideObject equals: Rectangle.
self assert: in rightSideObject equals: Point.
! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: (7@7)! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: Point! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testRightSideObjectOfListItemAtRow4
self assert: (s rightSideObjectOfListItemAtRow: 4) equals: 7! !

!DiffOnlyDSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testRightSideObjectOfListItemAtRow5
self assert: (s rightSideObjectOfListItemAtRow: 5) equals: 7! !

DiffOnlyDiffSheetTest subclass: #DiffOnlyDSRightDifferentRectanglesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 18:42'!
setUp
super setUp.
s leftSideObject: (2@3 corner: 10@15).
s rightSideObject: (2@3 corner: 20@15).
! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifference
self deny: (s canOpenInnerDifferenceAtKey: 'origin').
self assert: (s canOpenInnerDifferenceAtKey: 'corner').
! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 12/27/2012 11:08'!
testCanOpenInnerDifferenceAtKeyIndex2
self assert: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 12/27/2012 11:07'!
testCanOpenInspectorLeft2
self assert: (s canOpenLeftInspectorAtRowIndex: 2)! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 12/27/2012 11:07'!
testCanOpenInspectorRight2
self assert: (s canOpenRightInspectorAtRowIndex: 2)! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:23'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#different 'object' '(2@3) corner: (10@15)' '(2@3) corner: (20@15)') 
	#(#different 'corner' '(10@15)' '(20@15)'))
! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/27/2012 11:05'!
testDiffKeyAtRow2
self assert: (s diffKeyAtRow: 2) equals: 'corner'! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #different! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/27/2012 11:05'!
testDiffTypeAtRow2
self assert: (s diffTypeAtRow: 2) equals: #different! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: (2@3 corner: 10@15)! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 12/27/2012 11:07'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: (10@15)! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/27/2012 11:03'!
testListRowSize
self assert: s listRowSize equals: 2! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:06'!
testOpenInnerDifferenceAtKey
| indi |
indi := (s openInnerDifferenceAtKey: 'corner').
self assert: indi comparisonResultInLiterals equals: 
#(
	#(#different 'object' '(10@15)' '(20@15)') 
	#(#identical 'class' 'Point' 'Point') 
	#(#different 'x' '10' '20') 
	#(#identical 'y' '15' '15'))! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 12/27/2012 11:08'!
testOpenInnerDifferenceAtKeyIndex2
| in |
in := (s openInnerDifferenceAtKeyIndex: 2).
self assert: in leftSideObject equals: (10@15).
self assert: in rightSideObject equals: (20@15).
! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: (2@3 corner: 20@15).! !

!DiffOnlyDSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 12/27/2012 11:07'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: (20@15)! !

DiffOnlyDiffSheetTest subclass: #DiffOnlyDSRightShortStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DiffOnlyDSRightShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 18:42'!
setUp
super setUp.
s leftSideObject: 'hello'.
s rightSideObject: 'hell'.
! !

!DiffOnlyDSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 12/27/2012 11:46'!
testCanOpenInnerDifference
self assert: (s canOpenInnerDifferenceLiteralForm) equals: 
#(
	#('object' false) 
	#('size' false) 
	#('5' false))! !

!DiffOnlyDSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/27/2012 11:44'!
testCanOpenInspector
self assert: (s canOpenInspectorLiteralForm) equals: 
#(
	#('object' true true) 
	#('size' true true) 
	#('5' true false))! !

!DiffOnlyDSRightShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:22'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#different 'object' '''hello''' '''hell''') 
	#(#different 'size' '5' '4') 
	#(#rightMissing '5' '$o' ''))
! !

!DiffOnlyDSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DiffOnlyDSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/27/2012 11:11'!
testDiffKeyAtRow2
self assert: (s diffKeyAtRow: 2) equals: 'size'! !

!DiffOnlyDSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/27/2012 11:11'!
testDiffKeyAtRow3
self assert: (s diffKeyAtRow: 3) equals: '5'! !

!DiffOnlyDSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #different! !

!DiffOnlyDSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/27/2012 11:12'!
testDiffTypeAtRow2
self assert: (s diffTypeAtRow: 2) equals: #different! !

!DiffOnlyDSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/27/2012 11:12'!
testDiffTypeAtRow3
self assert: (s diffTypeAtRow: 3) equals: #rightMissing! !

!DiffOnlyDSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: 'hello'! !

!DiffOnlyDSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/27/2012 11:17'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: 5! !

!DiffOnlyDSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/27/2012 11:12'!
testListItemOfRightSideAtRow3
self assert: (s itemStringOfRightSideAtRow: 3) equals: ''! !

!DiffOnlyDSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/27/2012 11:11'!
testListRowSize
self assert: s listRowSize equals: 3! !

!DiffOnlyDSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 18:42'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: 'hell'! !

!DiffOnlyDSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/27/2012 11:17'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: 4! !

DiffOnlyDiffSheetTest subclass: #DiffOnlyDSSameLengthStringsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DiffOnlyDSSameLengthStringsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 18:42'!
setUp
super setUp.
s leftSideObject: 'hell'.
s rightSideObject: 'llll'.
! !

!DiffOnlyDSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/27/2012 12:19'!
testCanOpenInnerDifference
	self assert: (s canOpenInspectorLiteralForm) equals:
#(
	#('object' true true) 
	#('1' true true) 
	#('2' true true))! !

!DiffOnlyDSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/27/2012 12:17'!
testCanOpenInspector
self assert: (s canOpenInspectorLiteralForm) equals: 
#(
	#('object' true true) 
	#('1' true true) 
	#('2' true true))! !

!DiffOnlyDSSameLengthStringsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:18'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#different 'object' '''hell''' '''llll''') 
	#(#different '1' '$h' '$l') 
	#(#different '2' '$e' '$l'))
! !

!DiffOnlyDSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/27/2012 11:55'!
testObjectsLiteralForm
self assert: (s objectsLiteralForm) equals: 
#(
	#('object' 'hell' 'llll') 
	#('1' $h $l) 
	#('2' $e $l))! !

!DiffOnlyDSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/27/2012 11:58'!
testOpenInnerDifferenceAtKeyIndex2
| in |
in := (s openInnerDifferenceAtKeyIndex: 2).
self assert: in leftSideObject equals: $h.
self assert: in rightSideObject equals: $l.
! !

!DiffOnlyDSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/27/2012 11:58'!
testOpenInnerDifferenceAtKeyIndex3
| in |
in := (s openInnerDifferenceAtKeyIndex: 3).
self assert: in leftSideObject equals: $e.
self assert: in rightSideObject equals: $l.
! !

!DiffOnlyDiffSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 18:42'!
openGUI
(ObjectDiffGUI on: s) open.! !

!DiffOnlyDiffSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 22:29'!
setUp
super setUp.
s := DiffSheet new.
s beShowDifferentOnly.! !

TestCase subclass: #DiffSheetTest
	instanceVariableNames: 's'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

DiffSheetTest subclass: #DSEqualPointsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSEqualPointsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:19'!
setUp
super setUp.
s leftSideObject: 2@3.
s rightSideObject: 2@3.
! !

!DSEqualPointsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 18:35'!
testCanOpenInnerDifference
self deny: (s canOpenInnerDifferenceAtKey: 'x').
self deny: (s canOpenInnerDifferenceAtKey: 'y').! !

!DSEqualPointsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 18:58'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:32'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 20:58'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSEqualPointsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:04'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#equal 'object' '(2@3)' '(2@3)'))! !

!DSEqualPointsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DSEqualPointsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #equal! !

!DSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:08'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: (2 @ 3)! !

!DSEqualPointsTest methodsFor: 'list' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
self assert: s listRowSize equals: 1! !

!DSEqualPointsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:38'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: (2 @ 3)! !

DiffSheetTest subclass: #DSIdenticalIntegersTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSIdenticalIntegersTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:21'!
setUp
super setUp.
s leftSideObject: 37.
s rightSideObject: 37.
! !

!DSIdenticalIntegersTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 18:35'!
testCanOpenInnerDifference
self deny: (s canOpenInnerDifferenceAtKey: 'foo').
! !

!DSIdenticalIntegersTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:00'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:00'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSIdenticalIntegersTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:03'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#identical 'object' '37' '37')).! !

!DSIdenticalIntegersTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DSIdenticalIntegersTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #identical! !

!DSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:10'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: 37! !

!DSIdenticalIntegersTest methodsFor: 'list' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
self assert: s listRowSize equals: 1! !

!DSIdenticalIntegersTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:40'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: 37! !

DiffSheetTest subclass: #DSIntervalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSIntervalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 13:21'!
setUp
	super setUp.
	s leftSideObject: (1 to: 6).
	s rightSideObject: (7 to: 10).! !

!DSIntervalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 13:47'!
testComparisonResultInLiterals
	self assert: s comparisonResultInLiterals equals:
#(
	#(#different 'object' '(1 to: 6)' '(7 to: 10)' )
	#(#identical 'class' 'Interval' 'Interval')
	#(#different 'start' '1' '7')
	#(#different 'stop' '6' '10')
	#(#identical 'step' '1' '1')
)! !

DiffSheetTest subclass: #DSLeftShortStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSLeftShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:28'!
setUp
super setUp.
s leftSideObject: 'hell'.
s rightSideObject: 'hello'.
! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:00'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:06'!
testCanOpenInnerDifferenceAtKeyIndex2
self deny: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:09'!
testCanOpenInnerDifferenceAtKeyIndex3
self deny: (s canOpenInnerDifferenceAtKeyIndex: 3)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:09'!
testCanOpenInnerDifferenceAtKeyIndex4
self deny: (s canOpenInnerDifferenceAtKeyIndex: 4)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:09'!
testCanOpenInnerDifferenceAtKeyIndex5
self deny: (s canOpenInnerDifferenceAtKeyIndex: 5)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:09'!
testCanOpenInnerDifferenceAtKeyIndex6
self deny: (s canOpenInnerDifferenceAtKeyIndex: 6)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:07'!
testCanOpenInnerDifferenceAtKeyIndex7
self deny: (s canOpenInnerDifferenceAtKeyIndex: 7)! !

!DSLeftShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 14:29'!
testCanOpenInnerDifferenceAtKeyIndex8
self deny: (s canOpenInnerDifferenceAtKeyIndex: 8)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:35'!
testCanOpenInspectorLeft2
self assert: (s canOpenLeftInspectorAtRowIndex: 2)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:35'!
testCanOpenInspectorLeft4
self assert: (s canOpenLeftInspectorAtRowIndex: 4)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:35'!
testCanOpenInspectorLeft8
self deny: (s canOpenLeftInspectorAtRowIndex: 8)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:01'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:03'!
testCanOpenInspectorRight2
self assert: (s canOpenRightInspectorAtRowIndex: 2)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:03'!
testCanOpenInspectorRight3
self assert: (s canOpenRightInspectorAtRowIndex: 3)! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:04'!
testCanOpenInspectorRight7
self assert: (s canOpenRightInspectorAtRowIndex: 7)! !

!DSLeftShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:15'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#different 'object' '''hell''' '''hello''') 
	#(#identical 'class' 'ByteString' 'ByteString') 
	#(#different 'size' '4' '5') 
	#(#identical '1' '$h' '$h') 
	#(#identical '2' '$e' '$e') 
	#(#identical '3' '$l' '$l') 
	#(#identical '4' '$l' '$l') 
	#(#leftMissing '5' '' '$o'))! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow2
self assert: (s diffKeyAtRow: 2) equals: 'class'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow3
self assert: (s diffKeyAtRow: 3) equals: 'size'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow4
self assert: (s diffKeyAtRow: 4) equals: '1'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow5
self assert: (s diffKeyAtRow: 5) equals: '2'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow6
self assert: (s diffKeyAtRow: 6) equals: '3'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:51'!
testDiffKeyAtRow7
self assert: (s diffKeyAtRow: 7) equals: '4'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:51'!
testDiffKeyAtRow8
self assert: (s diffKeyAtRow: 8) equals: '5'! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #different! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow2
self assert: (s diffTypeAtRow: 2) equals: #identical! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow3
self assert: (s diffTypeAtRow: 3) equals: #different! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow4
self assert: (s diffTypeAtRow: 4) equals: #identical! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow5
self assert: (s diffTypeAtRow: 5) equals: #identical! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow6
self assert: (s diffTypeAtRow: 6) equals: #identical! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow7
self assert: (s diffTypeAtRow: 7) equals: #identical! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:55'!
testDiffTypeAtRow8
self assert: (s diffTypeAtRow: 8) equals: #leftMissing! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:52'!
testLeftItemString8
self assert: (s itemStringOfLeftSideAtRow: 8) equals: ''! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:11'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: 'hell'! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:35'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 14:47'!
testLeftSideObjectOfListItemAtRow3
self assert: (s leftSideObjectOfListItemAtRow: 3) equals: 4! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 14:46'!
testLeftSideObjectOfListItemAtRow4
self assert: (s leftSideObjectOfListItemAtRow: 4) equals: $h! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 14:46'!
testLeftSideObjectOfListItemAtRow5
self assert: (s leftSideObjectOfListItemAtRow: 5) equals: $e! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:37'!
testLeftSideObjectOfListItemAtRow6
self assert: (s leftSideObjectOfListItemAtRow: 6) equals: $l! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 14:41'!
testLeftSideObjectOfListItemAtRow7
self assert: (s leftSideObjectOfListItemAtRow: 7) equals: $l! !

!DSLeftShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 15:59'!
testListRowSize
self assert: s listRowSize equals: 8! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:44'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: 'hello'! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:44'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:13'!
testRightSideObjectOfListItemAtRow3
self assert: (s rightSideObjectOfListItemAtRow: 3) equals: 5! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:13'!
testRightSideObjectOfListItemAtRow4
self assert: (s rightSideObjectOfListItemAtRow: 4) equals: $h! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:13'!
testRightSideObjectOfListItemAtRow5
self assert: (s rightSideObjectOfListItemAtRow: 5) equals: $e! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:13'!
testRightSideObjectOfListItemAtRow6
self assert: (s rightSideObjectOfListItemAtRow: 6) equals: $l! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:12'!
testRightSideObjectOfListItemAtRow7
self assert: (s rightSideObjectOfListItemAtRow: 7) equals: $l! !

!DSLeftShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:12'!
testRightSideObjectOfListItemAtRow8
self assert: (s rightSideObjectOfListItemAtRow: 8) equals: $o! !

DiffSheetTest subclass: #DSRectanglePointTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSRectanglePointTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:55'!
setUp
super setUp.
s leftSideObject: (10@5 corner: 20@20).
s rightSideObject: (7@7).
! !

!DSRectanglePointTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 15:05'!
testBalloonText
self assert: (s listItemAtRow: 4) balloonText equals: 
'x:
	
	7'! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:02'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:11'!
testCanOpenInnerDifferenceAtKeyIndex2
self assert: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:11'!
testCanOpenInnerDifferenceAtKeyIndex3
self deny: (s canOpenInnerDifferenceAtKeyIndex: 3)! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:11'!
testCanOpenInnerDifferenceAtKeyIndex4
self deny: (s canOpenInnerDifferenceAtKeyIndex: 4)! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:10'!
testCanOpenInnerDifferenceAtKeyIndex5
self deny: (s canOpenInnerDifferenceAtKeyIndex: 5)! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:10'!
testCanOpenInnerDifferenceAtKeyIndex6
self deny: (s canOpenInnerDifferenceAtKeyIndex: 6)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:41'!
testCanOpenInspectorLeft2
self assert: (s canOpenLeftInspectorAtRowIndex: 2)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:41'!
testCanOpenInspectorLeft3
self assert: (s canOpenLeftInspectorAtRowIndex: 3)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:41'!
testCanOpenInspectorLeft4
self deny: (s canOpenLeftInspectorAtRowIndex: 4)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:41'!
testCanOpenInspectorLeft5
self deny: (s canOpenLeftInspectorAtRowIndex: 5)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:42'!
testCanOpenInspectorLeft6
self assert: (s canOpenLeftInspectorAtRowIndex: 6)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:05'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:06'!
testCanOpenInspectorRight2
self assert: (s canOpenRightInspectorAtRowIndex: 2)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:07'!
testCanOpenInspectorRight3
self deny: (s canOpenRightInspectorAtRowIndex: 3)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:06'!
testCanOpenInspectorRight4
self assert: (s canOpenRightInspectorAtRowIndex: 4)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:06'!
testCanOpenInspectorRight5
self assert: (s canOpenRightInspectorAtRowIndex: 5)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:08'!
testCanOpenInspectorRight6
self deny: (s canOpenRightInspectorAtRowIndex: 6)! !

!DSRectanglePointTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:24'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#different 'object' '(10@5) corner: (20@20)' '(7@7)') 
	#(#different 'class' 'Rectangle' 'Point') 
	#(#rightMissing 'origin' '(10@5)' '') 
	#(#leftMissing 'x' '' '7') 
	#(#leftMissing 'y' '' '7') 
	#(#rightMissing 'corner' '(20@20)' ''))! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow2
self assert: (s diffKeyAtRow: 2) equals: 'class'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow3
self assert: (s diffKeyAtRow: 3) equals: 'origin'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow4
self assert: (s diffKeyAtRow: 4) equals: 'x'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow5
self assert: (s diffKeyAtRow: 5) equals: 'y'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow6
self assert: (s diffKeyAtRow: 6) equals: 'corner'! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #different! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow2
self assert: (s diffTypeAtRow: 2) equals: #different! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow3
self assert: (s diffTypeAtRow: 3) equals: #rightMissing! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow4
self assert: (s diffTypeAtRow: 4) equals: #leftMissing! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow5
self assert: (s diffTypeAtRow: 5) equals: #leftMissing! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow6
self assert: (s diffTypeAtRow: 6) equals: #rightMissing! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:14'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: (10@5 corner: 20@20)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:29'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: Rectangle! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:31'!
testLeftSideObjectOfListItemAtRow3
self assert: (s leftSideObjectOfListItemAtRow: 3) equals: (10@5)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:32'!
testLeftSideObjectOfListItemAtRow6
self assert: (s leftSideObjectOfListItemAtRow: 6) equals: (20@20)! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 15:58'!
testListItemOfLeftSideAtRow4
self assert: (s itemStringOfLeftSideAtRow: 4) equals: ''! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 15:58'!
testListItemOfLeftSideAtRow5
self assert: (s itemStringOfLeftSideAtRow: 5) equals: ''! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 15:58'!
testListItemOfRightSideAtRow3
self assert: (s itemStringOfRightSideAtRow: 3) equals: ''! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 15:58'!
testListItemOfRightSideAtRow6
self assert: (s itemStringOfRightSideAtRow: 6) equals: ''! !

!DSRectanglePointTest methodsFor: 'list' stamp: 'HwaJong 10/30/2012 03:02'!
testListRowSize
self assert: s listRowSize equals: 6! !

!DSRectanglePointTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 22:36'!
testOpenInnerDifferenceAtKeyIndex2
| in |
in := (s openInnerDifferenceAtKeyIndex: 2).
self assert: in leftSideObject equals: Rectangle.
self assert: in rightSideObject equals: Point.
! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:53'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: (7@7)! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:53'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: Point! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:56'!
testRightSideObjectOfListItemAtRow4
self assert: (s rightSideObjectOfListItemAtRow: 4) equals: 7! !

!DSRectanglePointTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:56'!
testRightSideObjectOfListItemAtRow5
self assert: (s rightSideObjectOfListItemAtRow: 5) equals: 7! !

DiffSheetTest subclass: #DSRightDifferentRectanglesTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:23'!
setUp
super setUp.
s leftSideObject: (2@3 corner: 10@15).
s rightSideObject: (2@3 corner: 20@15).
! !

!DSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 18:35'!
testCanOpenInnerDifference
self deny: (s canOpenInnerDifferenceAtKey: 'origin').
self assert: (s canOpenInnerDifferenceAtKey: 'corner').
! !

!DSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:02'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:14'!
testCanOpenInnerDifferenceAtKeyIndex2
self deny: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:14'!
testCanOpenInnerDifferenceAtKeyIndex3
self deny: (s canOpenInnerDifferenceAtKeyIndex: 3)! !

!DSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:13'!
testCanOpenInnerDifferenceAtKeyIndex4
self assert: (s canOpenInnerDifferenceAtKeyIndex: 4)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:43'!
testCanOpenInspectorLeft2
self assert: (s canOpenLeftInspectorAtRowIndex: 2)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:43'!
testCanOpenInspectorLeft3
self assert: (s canOpenLeftInspectorAtRowIndex: 3)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:43'!
testCanOpenInspectorLeft4
self assert: (s canOpenLeftInspectorAtRowIndex: 4)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:09'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:09'!
testCanOpenInspectorRight2
self assert: (s canOpenRightInspectorAtRowIndex: 2)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:09'!
testCanOpenInspectorRight3
self assert: (s canOpenRightInspectorAtRowIndex: 3)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:09'!
testCanOpenInspectorRight4
self assert: (s canOpenRightInspectorAtRowIndex: 4)! !

!DSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:08'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#different 'object' '(2@3) corner: (10@15)' '(2@3) corner: (20@15)') 
	#(#identical 'class' 'Rectangle' 'Rectangle') 
	#(#equal 'origin' '(2@3)' '(2@3)') 
	#(#different 'corner' '(10@15)' '(20@15)'))! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow2
self assert: (s diffKeyAtRow: 2) equals: 'class'! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow3
self assert: (s diffKeyAtRow: 3) equals: 'origin'! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow4
self assert: (s diffKeyAtRow: 4) equals: 'corner'! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #different! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow2
self assert: (s diffTypeAtRow: 2) equals: #identical! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow3
self assert: (s diffTypeAtRow: 3) equals: #equal! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow4
self assert: (s diffTypeAtRow: 4) equals: #different! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:14'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: (2@3 corner: 10@15)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:27'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: Rectangle! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:27'!
testLeftSideObjectOfListItemAtRow3
self assert: (s leftSideObjectOfListItemAtRow: 3) equals: (2@3)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:27'!
testLeftSideObjectOfListItemAtRow4
self assert: (s leftSideObjectOfListItemAtRow: 4) equals: (10@15)! !

!DSRightDifferentRectanglesTest methodsFor: 'list' stamp: 'HwaJong 10/28/2012 21:52'!
testListRowSize
self assert: s listRowSize equals: 4! !

!DSRightDifferentRectanglesTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 00:43'!
testOpenInnerDifferenceAtKey
| indi |
indi := (s openInnerDifferenceAtKey: 'corner').
self assert: indi comparisonResultInLiterals equals: #(#(#different 'object' '(10@15)' '(20@15)') #(#identical 'class' 'Point' 'Point') #(#different 'x' '10' '20') #(#identical 'y' '15' '15'))! !

!DSRightDifferentRectanglesTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 22:37'!
testOpenInnerDifferenceAtKeyIndex4
| in |
in := (s openInnerDifferenceAtKeyIndex: 4).
self assert: in leftSideObject equals: (10@15).
self assert: in rightSideObject equals: (20@15).
! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:01'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: (2@3 corner: 20@15).! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:00'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: Rectangle! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:00'!
testRightSideObjectOfListItemAtRow3
self assert: (s rightSideObjectOfListItemAtRow: 3) equals: (2@3)! !

!DSRightDifferentRectanglesTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:58'!
testRightSideObjectOfListItemAtRow4
self assert: (s rightSideObjectOfListItemAtRow: 4) equals: (20@15)! !

DiffSheetTest subclass: #DSRightShortStringTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSRightShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:29'!
setUp
super setUp.
s leftSideObject: 'hello'.
s rightSideObject: 'hell'.
! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:03'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex2
self deny: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex3
self deny: (s canOpenInnerDifferenceAtKeyIndex: 3)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex4
self deny: (s canOpenInnerDifferenceAtKeyIndex: 4)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex5
self deny: (s canOpenInnerDifferenceAtKeyIndex: 5)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex6
self deny: (s canOpenInnerDifferenceAtKeyIndex: 6)! !

!DSRightShortStringTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:15'!
testCanOpenInnerDifferenceAtKeyIndex7
self deny: (s canOpenInnerDifferenceAtKeyIndex: 7)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:45'!
testCanOpenInspectorLeft2
self assert: (s canOpenLeftInspectorAtRowIndex: 2)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:45'!
testCanOpenInspectorLeft3
self assert: (s canOpenLeftInspectorAtRowIndex: 3)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:45'!
testCanOpenInspectorLeft7
self assert: (s canOpenLeftInspectorAtRowIndex: 7)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:17'!
testCanOpenInspectorRight1
self assert: (s canOpenRightInspectorAtRowIndex: 1)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:17'!
testCanOpenInspectorRight2
self assert: (s canOpenRightInspectorAtRowIndex: 2)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:17'!
testCanOpenInspectorRight3
self assert: (s canOpenRightInspectorAtRowIndex: 3)! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:10'!
testCanOpenInspectorRight8
self deny: (s canOpenRightInspectorAtRowIndex: 8)! !

!DSRightShortStringTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:02'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#different 'object' '''hello''' '''hell''') 
	#(#identical 'class' 'ByteString' 'ByteString') 
	#(#different 'size' '5' '4') 
	#(#identical '1' 	'$h' '$h') 
	#(#identical '2' '$e' '$e') 
	#(#identical '3' '$l' '$l') 
	#(#identical '4' '$l' '$l') 
	#(#rightMissing '5' '$o' ''))
! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow2
self assert: (s diffKeyAtRow: 2) equals: 'class'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow3
self assert: (s diffKeyAtRow: 3) equals: 'size'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow4
self assert: (s diffKeyAtRow: 4) equals: '1'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow5
self assert: (s diffKeyAtRow: 5) equals: '2'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow6
self assert: (s diffKeyAtRow: 6) equals: '3'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:51'!
testDiffKeyAtRow7
self assert: (s diffKeyAtRow: 7) equals: '4'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:51'!
testDiffKeyAtRow8
self assert: (s diffKeyAtRow: 8) equals: '5'! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #different! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow2
self assert: (s diffTypeAtRow: 2) equals: #identical! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow3
self assert: (s diffTypeAtRow: 3) equals: #different! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow4
self assert: (s diffTypeAtRow: 4) equals: #identical! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow5
self assert: (s diffTypeAtRow: 5) equals: #identical! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow6
self assert: (s diffTypeAtRow: 6) equals: #identical! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow7
self assert: (s diffTypeAtRow: 7) equals: #identical! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:55'!
testDiffTypeAtRow8
self assert: (s diffTypeAtRow: 8) equals: #rightMissing! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:15'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: 'hello'! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 16:18'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:11'!
testLeftSideObjectOfListItemAtRow3
self assert: (s leftSideObjectOfListItemAtRow: 3) equals: 5! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:11'!
testLeftSideObjectOfListItemAtRow4
self assert: (s leftSideObjectOfListItemAtRow: 4) equals: $h! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:11'!
testLeftSideObjectOfListItemAtRow5
self assert: (s leftSideObjectOfListItemAtRow: 5) equals: $e! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:11'!
testLeftSideObjectOfListItemAtRow6
self assert: (s leftSideObjectOfListItemAtRow: 6) equals: $l! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:11'!
testLeftSideObjectOfListItemAtRow7
self assert: (s leftSideObjectOfListItemAtRow: 7) equals: $l! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 15:58'!
testListItemOfRightSideAtRow8
self assert: (s itemStringOfRightSideAtRow: 8) equals: ''! !

!DSRightShortStringTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 15:59'!
testListRowSize
self assert: s listRowSize equals: 8! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:02'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: 'hell'! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:02'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:32'!
testRightSideObjectOfListItemAtRow3
self assert: (s rightSideObjectOfListItemAtRow: 3) equals: 4! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:31'!
testRightSideObjectOfListItemAtRow4
self assert: (s rightSideObjectOfListItemAtRow: 4) equals: $h! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:31'!
testRightSideObjectOfListItemAtRow5
self assert: (s rightSideObjectOfListItemAtRow: 5) equals: $e! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:31'!
testRightSideObjectOfListItemAtRow6
self assert: (s rightSideObjectOfListItemAtRow: 6) equals: $l! !

!DSRightShortStringTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:31'!
testRightSideObjectOfListItemAtRow7
self assert: (s rightSideObjectOfListItemAtRow: 7) equals: $l! !

DiffSheetTest subclass: #DSSameLengthStringsTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Test'!

!DSSameLengthStringsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 20:26'!
setUp
super setUp.
s leftSideObject: 'hell'.
s rightSideObject: 'llll'.
! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:04'!
testCanOpenInnerDifferenceAtKeyIndex1
self deny: (s canOpenInnerDifferenceAtKeyIndex: 1)! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 10/31/2012 19:16'!
testCanOpenInnerDifferenceAtKeyIndex2
self deny: (s canOpenInnerDifferenceAtKeyIndex: 2)! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 14:39'!
testCanOpenInnerDifferenceAtKeyIndex3
self deny: (s canOpenInnerDifferenceAtKeyIndex: 3)! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 14:39'!
testCanOpenInnerDifferenceAtKeyIndex4
self assert: (s canOpenInnerDifferenceAtKeyIndex: 4)! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 14:38'!
testCanOpenInnerDifferenceAtKeyIndex5
self assert: (s canOpenInnerDifferenceAtKeyIndex: 5)! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 14:38'!
testCanOpenInnerDifferenceAtKeyIndex6
self deny: (s canOpenInnerDifferenceAtKeyIndex: 6)! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 14:38'!
testCanOpenInnerDifferenceAtKeyIndex7
self deny: (s canOpenInnerDifferenceAtKeyIndex: 7)! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 19:33'!
testCanOpenInspectorLeft1
self assert: (s canOpenLeftInspectorAtRowIndex: 1)! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 21:19'!
testCanOpenInspectorRight4
self assert: (s canOpenRightInspectorAtRowIndex: 4)! !

!DSSameLengthStringsTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:23'!
testComparisonResultInLiterals
self assert: s comparisonResultInLiterals equals: 
#(
	#(#different 'object' '''hell''' '''llll''') 
	#(#identical 'class' 'ByteString' 'ByteString') 
	#(#identical 'size' '4' '4') 
	#(#different '1' '$h' '$l') 
	#(#different '2' '$e' '$l') 
	#(#identical '3' '$l' '$l') 
	#(#identical '4' '$l' '$l'))! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow1
self assert: (s diffKeyAtRow: 1) equals: 'object'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow2
self assert: (s diffKeyAtRow: 2) equals: 'class'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:49'!
testDiffKeyAtRow3
self assert: (s diffKeyAtRow: 3) equals: 'size'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow4
self assert: (s diffKeyAtRow: 4) equals: '1'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow5
self assert: (s diffKeyAtRow: 5) equals: '2'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:50'!
testDiffKeyAtRow6
self assert: (s diffKeyAtRow: 6) equals: '3'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:51'!
testDiffKeyAtRow7
self assert: (s diffKeyAtRow: 7) equals: '4'! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow1
self assert: (s diffTypeAtRow: 1) equals: #different! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow2
self assert: (s diffTypeAtRow: 2) equals: #identical! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow3
self assert: (s diffTypeAtRow: 3) equals: #identical! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:53'!
testDiffTypeAtRow4
self assert: (s diffTypeAtRow: 4) equals: #different! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow5
self assert: (s diffTypeAtRow: 5) equals: #different! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow6
self assert: (s diffTypeAtRow: 6) equals: #identical! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 18:54'!
testDiffTypeAtRow7
self assert: (s diffTypeAtRow: 7) equals: #identical! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:15'!
testLeftSideObjectOfListItemAtRow1
self assert: (s leftSideObjectOfListItemAtRow: 1) equals: 'hell'! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 15:16'!
testLeftSideObjectOfListItemAtRow2
self assert: (s leftSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:16'!
testLeftSideObjectOfListItemAtRow3
self assert: (s leftSideObjectOfListItemAtRow: 3) equals: 4! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:16'!
testLeftSideObjectOfListItemAtRow4
self assert: (s leftSideObjectOfListItemAtRow: 4) equals: $h! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:16'!
testLeftSideObjectOfListItemAtRow5
self assert: (s leftSideObjectOfListItemAtRow: 5) equals: $e! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:16'!
testLeftSideObjectOfListItemAtRow6
self assert: (s leftSideObjectOfListItemAtRow: 6) equals: $l! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:16'!
testLeftSideObjectOfListItemAtRow7
self assert: (s leftSideObjectOfListItemAtRow: 7) equals: $l! !

!DSSameLengthStringsTest methodsFor: 'list' stamp: 'HwaJong 12/26/2012 15:59'!
testListRowSize
self assert: s listRowSize equals: 7! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 15:14'!
testOpenInnerDifferenceAtKeyIndex4
| in |
in := (s openInnerDifferenceAtKeyIndex: 4).
self assert: in leftSideObject equals: $h.
self assert: in rightSideObject equals: $l.
! !

!DSSameLengthStringsTest methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 15:14'!
testOpenInnerDifferenceAtKeyIndex5
| in |
in := (s openInnerDifferenceAtKeyIndex: 5).
self assert: in leftSideObject equals: $e.
self assert: in rightSideObject equals: $l.
! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:10'!
testRightSideObjectOfListItemAtRow1
self assert: (s rightSideObjectOfListItemAtRow: 1) equals: 'llll'! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 10/31/2012 17:10'!
testRightSideObjectOfListItemAtRow2
self assert: (s rightSideObjectOfListItemAtRow: 2) equals: ByteString! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:38'!
testRightSideObjectOfListItemAtRow3
self assert: (s rightSideObjectOfListItemAtRow: 3) equals: 4! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:38'!
testRightSideObjectOfListItemAtRow4
self assert: (s rightSideObjectOfListItemAtRow: 4) equals: $l! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:38'!
testRightSideObjectOfListItemAtRow5
self assert: (s rightSideObjectOfListItemAtRow: 5) equals: $l! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:38'!
testRightSideObjectOfListItemAtRow6
self assert: (s rightSideObjectOfListItemAtRow: 6) equals: $l! !

!DSSameLengthStringsTest methodsFor: 'inspect' stamp: 'HwaJong 12/26/2012 15:38'!
testRightSideObjectOfListItemAtRow7
self assert: (s rightSideObjectOfListItemAtRow: 7) equals: $l! !

!DiffSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 13:01'!
openGUI
(ObjectDiffGUI on: s) open.! !

!DiffSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 22:29'!
setUp
super setUp.
s := DiffSheet new.! !

TestCase subclass: #ODSheetTest
	instanceVariableNames: 'sheet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet-Test'!

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:34'!
setUp
super setUp.
sheet := ODSheet new.
sheet objects: {'hello'. 19. World}.
sheet accesses: {[:o| o sizeInMemory]. [:o| o className]. [:o| o even]}.
! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:35'!
testValueAt1At1
self assert: (sheet valueOfObjectAt: 1 byAccessAt: 1) equals: 9! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:31'!
testValueAt1At2
self assert: (sheet valueOfObjectAt: 1 byAccessAt: 2) equals: 'ByteString'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:29'!
testValueAt1At3
self assert: ((sheet valueOfObjectAt: 1 byAccessAt: 3) isKindOf: MessageNotUnderstood).! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:35'!
testValueAt2At1
self assert: (sheet valueOfObjectAt: 2 byAccessAt: 1) equals: 0! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:36'!
testValueAt2At2
self assert: (sheet valueOfObjectAt: 2 byAccessAt: 2) equals: 'SmallInteger'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:39'!
testValueAt2At3
self deny: (sheet valueOfObjectAt: 2 byAccessAt: 3).! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:36'!
testValueAt3At1
self assert: (sheet valueOfObjectAt: 3 byAccessAt: 1) equals: 52! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:37'!
testValueAt3At2
self assert: (sheet valueOfObjectAt: 3 byAccessAt: 2) equals: 'PasteUpMorph'! !

!ODSheetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:39'!
testValueAt3At3
self assert: ((sheet valueOfObjectAt: 3 byAccessAt: 3) isKindOf: MessageNotUnderstood).! !

TestCase subclass: #ObjectDiffSystemTest
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

ObjectDiffSystemTest subclass: #ODSArrayTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:17'!
setUp
super setUp.
object := #(10 20 30 40).! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:06'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: (1 to: 4)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt1
self assert: (object objectDiffValueAt: 1) equals: (10)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt2
self assert: (object objectDiffValueAt: 2) equals: (20)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt3
self assert: (object objectDiffValueAt: 3) equals: (30)! !

!ODSArrayTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:19'!
testObjectDiffValueAt4
self assert: (object objectDiffValueAt: 4) equals: (40)! !

ObjectDiffSystemTest subclass: #ODSDictionaryTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:06'!
setUp
super setUp.
object := Dictionary new.
object at: 'hello' put: 'kitty'.
object at: 30 put: 'thirty'.
! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:07'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: {30. 'hello'}! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:22'!
testObjectDiffValueAt30
self assert: (object objectDiffValueAt: 30) equals: ('thirty')! !

!ODSDictionaryTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:21'!
testObjectDiffValueAtHello
self assert: (object objectDiffValueAt: 'hello') equals: ('kitty')! !

ObjectDiffSystemTest subclass: #ODSDomainErrorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSDomainErrorTest commentStamp: 'HwaJong 10/31/2012 17:20' prior: 0!
test for accessing instance variables defined distinct classes of a hierarchy.!

!ODSDomainErrorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:19'!
setUp
super setUp.
object := DomainError new messageText: 'do better!!'; from: 10; to: 100.! !

!ODSDomainErrorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:16'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: {'messageText'. 'tag'. 'signaler'. 'signalContext'. 'handlerContext'. 'outerContext'. 'from'. 'to'}! !

!ODSDomainErrorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:19'!
testObjectDiffValueAtFrom
self assert: (object objectDiffValueAt: 'from') equals: 10! !

!ODSDomainErrorTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 17:18'!
testObjectDiffValueAtMessageText
self assert: (object objectDiffValueAt: 'messageText') equals: 'do better!!'! !

ObjectDiffSystemTest subclass: #ODSIntervalTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSIntervalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 13:26'!
setUp
super setUp.
object := 5 to: 7 by: 2! !

!ODSIntervalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 13:26'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: {'start'. 'stop'. 'step'}! !

!ODSIntervalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 13:30'!
testObjectDiffValueAtStart
self assert: (object objectDiffValueAt: 'start') equals: 5! !

!ODSIntervalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 13:31'!
testObjectDiffValueAtStep
self assert: (object objectDiffValueAt: 'step') equals: 2! !

!ODSIntervalTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 13:31'!
testObjectDiffValueAtStop
self assert: (object objectDiffValueAt: 'stop') equals: 7! !

ObjectDiffSystemTest subclass: #ODSObjectTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:07'!
setUp
super setUp.
object := (2@3) corner: (10@15).! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:08'!
testObjectDiffKeys
self assert: object objectDiffKeys equals: {'origin'. 'corner'}! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:27'!
testObjectDiffValueAtCorner
self assert: (object objectDiffValueAt: 'corner') equals: (10@15)! !

!ODSObjectTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:23'!
testObjectDiffValueAtOrigin
self assert: (object objectDiffValueAt: 'origin') equals: (2@3)! !

ObjectDiffSystemTest subclass: #ODSSetTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-System'!

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:09'!
setUp
super setUp.
object := Set new.
object add: 10.
object add: 'joy'.
! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:09'!
testObjectDiffKeys 
self assert: object objectDiffKeys equals: (1 to: 2)! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:30'!
testObjectDiffValueAt1
self assert: ({10. 'joy'} includes: (object objectDiffValueAt: 1))! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:33'!
testObjectDiffValueAt2
self assert: ({10. 'joy'} includes: (object objectDiffValueAt: 2))! !

!ODSSetTest methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/28/2012 00:34'!
testObjectDiffValueAtDiffers
self deny: ((object objectDiffValueAt: 1) = (object objectDiffValueAt: 2))! !

!SequenceableCollection methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/27/2012 22:21'!
objectDiffKeys
^self isEmpty
	ifTrue: [Array new]
	ifFalse: [1 to: self size]! !

!SequenceableCollection methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 00:18'!
objectDiffValueAt: anInteger 
^self at: anInteger! !

Object subclass: #DiffSheet
	instanceVariableNames: 'leftSideObject rightSideObject comparisonList isShowDifferentOnly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 11:23'!
beShowAll
	self isShowDifferentOnly: false! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 11:27'!
beShowDifferentOnly
	self isShowDifferentOnly: true! !

!DiffSheet methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 20:25'!
canOpenInnerDifferenceAtKey: anObject
^self comparisonList anySatisfy: [:each| each canOpenInnerDifferenceAtKey: anObject]
! !

!DiffSheet methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 20:32'!
canOpenInnerDifferenceAtKeyIndex: anInteger
^(self comparisonList at: anInteger) canOpenInnerDifference! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 11:45'!
canOpenInnerDifferenceLiteralForm
	^self comparisonList collect: [:each| each canOpenInnerDifferenceLiteralForm ]! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 11:42'!
canOpenInspectorLiteralForm
	^self comparisonList collect: [:each| each canOpenInspectorLiteralForm] ! !

!DiffSheet methodsFor: 'inspecting' stamp: 'HwaJong 12/26/2012 20:40'!
canOpenLeftInspectorAtRowIndex: anInteger
^(self comparisonList at: anInteger) canOpenLeftInspector! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 11:41'!
canOpenLeftInspectorLiteralForm
	self shouldBeImplemented.! !

!DiffSheet methodsFor: 'inspecting' stamp: 'HwaJong 12/26/2012 20:18'!
canOpenRightInspectorAtRowIndex: anInteger 
^(self comparisonList at: anInteger) canOpenRightInspector! !

!DiffSheet methodsFor: 'self evaluating' stamp: 'HwaJong 10/28/2012 01:46'!
commonKeys
|keySet|
keySet := Set new.
keySet addAll: leftSideObject objectDiffKeys.
keySet addAll: rightSideObject objectDiffKeys.
^keySet asArray! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 12/26/2012 22:15'!
comparisonList
	^comparisonList setDefault: #defaultComparisonList for: self withSetter: #comparisonList:! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 12/26/2012 22:16'!
comparisonList: anArray
	comparisonList := anArray! !

!DiffSheet methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 21:14'!
comparisonResultInLiterals
^self comparisonList collect: #literalForm! !

!DiffSheet methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 13:33'!
defaultComparisonList
| all |
leftSideObject == rightSideObject ifTrue: [^{JSNotInnerDifferableItem new leftSideObject: leftSideObject; rightSideObject: rightSideObject; comparison: [:e|e]; diffKey: 'object'}].
leftSideObject = rightSideObject ifTrue: [^{JSNotInnerDifferableItem new leftSideObject: leftSideObject; rightSideObject: rightSideObject; comparison: [:e|e]; diffKey: 'object'}].

all := Array streamContents: [:stream| 
	
	stream nextPut: (JSNotInnerDifferableItem new leftSideObject: leftSideObject; rightSideObject: rightSideObject; comparison: [:e|e]; diffKey: 'object').
	stream nextPut: (JSInnerDiffableItem new leftSideObject: leftSideObject; rightSideObject: rightSideObject; comparison: [:e| e class]; diffKey: 'class').
	
	(leftSideObject isCollectionToObjectDiff and: [rightSideObject isCollectionToObjectDiff])
		ifTrue: [stream nextPut: (JSNotInnerDifferableItem new leftSideObject: leftSideObject; rightSideObject: rightSideObject; comparison: [:e| e size]; diffKey: 'size')].
	
	self commonKeys do: [:key| stream nextPut: (JSItemWithKey new leftSideObject: leftSideObject; rightSideObject: rightSideObject; comparison: key)]
	].
	^self isShowDifferentOnly 
		ifTrue: [all select: [:each| each shouldBeShownOnDiffOnlyList ]]
		ifFalse: [all]! !

!DiffSheet methodsFor: 'self evaluating' stamp: 'HwaJong 12/27/2012 00:53'!
defaultIsShowDifferentOnly
	^false! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 12/26/2012 21:29'!
diffKeyAtRow: anInteger 
^(self comparisonList at: anInteger) diffKey asString.! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 12/26/2012 20:26'!
diffTypeAtRow: aSmallInteger 
^(self comparisonList at: aSmallInteger) diffItemType.! !

!DiffSheet methodsFor: 'controlling' stamp: 'HwaJong 12/27/2012 11:20'!
ifShowAll: aBlockClosure ifShowDifferentOnly: aBlockClosure2 
	^self isShowDifferentOnly 
		ifTrue: aBlockClosure2
		ifFalse: aBlockClosure! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 12/27/2012 00:52'!
isShowDifferentOnly
	^ isShowDifferentOnly setDefault: #defaultIsShowDifferentOnly for: self withSetter: #isShowDifferentOnly:! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 12/27/2012 11:27'!
isShowDifferentOnly: aBoolean 
	isShowDifferentOnly := aBoolean.
	self comparisonList: nil.! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 12/26/2012 15:58'!
itemStringOfLeftSideAtRow: aSmallInteger 
^(self listItemAtRow: aSmallInteger) diffLeftSidePrint.! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 12/26/2012 15:58'!
itemStringOfRightSideAtRow: aSmallInteger 
^(self listItemAtRow: aSmallInteger) diffRightSidePrint.! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 10/31/2012 22:34'!
leftSideObject
	^ leftSideObject! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 01:44'!
leftSideObject: anObject
leftSideObject := anObject! !

!DiffSheet methodsFor: 'inspecting' stamp: 'HwaJong 12/26/2012 20:41'!
leftSideObjectOfListItemAtRow: anInteger 
^(self comparisonList at: anInteger) leftSideObjectEvaluated! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 10/30/2012 12:07'!
listItemAtRow: anInteger 
^KSListItem diffSheet: self index: anInteger! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 10/30/2012 12:06'!
listItems
^(1 to: self listRowSize) collect: [:index| self listItemAtRow: index]! !

!DiffSheet methodsFor: 'list item' stamp: 'HwaJong 12/26/2012 20:33'!
listRowSize
^self comparisonList size.! !

!DiffSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 11:53'!
objectsLiteralForm
	^self comparisonList collect: [:each| each objectsLiteralForm ] ! !

!DiffSheet methodsFor: 'inner difference' stamp: 'HwaJong 10/28/2012 14:38'!
openInnerDifferenceAtKey: anObject 
^self class new
	leftSideObject: (leftSideObject objectDiffValueAt: anObject);
	rightSideObject: (rightSideObject objectDiffValueAt: anObject)! !

!DiffSheet methodsFor: 'inner difference' stamp: 'HwaJong 12/26/2012 21:01'!
openInnerDifferenceAtKeyIndex: anInteger 
^(self comparisonList at: anInteger) openInnerDifference! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 10/31/2012 22:35'!
rightSideObject
^ rightSideObject! !

!DiffSheet methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 01:45'!
rightSideObject: anObject 
rightSideObject := anObject! !

!DiffSheet methodsFor: 'inspecting' stamp: 'HwaJong 12/26/2012 20:31'!
rightSideObjectOfListItemAtRow: anInteger 
^(self comparisonList at: anInteger) rightSideObjectEvaluated.! !

Object subclass: #FormCache
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

FormCache class
	instanceVariableNames: 'TheFormThatCached'!

FormCache class
	instanceVariableNames: 'TheFormThatCached'!

!FormCache classSide methodsFor: 'accessing' stamp: 'HwaJong 10/31/2012 18:30'!
formThatCached
^TheFormThatCached setDefault: #defaultFormThatCached for: self withSetter: #formThatCached:! !

!FormCache classSide methodsFor: 'accessing' stamp: 'HwaJong 10/31/2012 18:30'!
formThatCached: aForm 
	TheFormThatCached := aForm! !

FormCache subclass: #ODDifferentIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ODDifferentIcon classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 18:30'!
defaultFormThatCached
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 167772160 16777216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 570425344 603979776 16777215 16777215 16777215 1107296256 1107296256 16777215 16777215 167772160 536870912 16777215 16777215 16777215 16777215 16777216 2147483648 251658240 16777215 16777215 16777215 167772160 2365587456 117440512 100663296 2583691264 872415232 16777215 16777215 16777215 16777215 1459617792 1476395008 1778384896 67108864 16777215 16777215 16777215 1275068416 1895825408 1946157056 1493172224 16777215 16777215 16777215 16777215 872415232 3036676096 1795162112 2533359616 1828716544 83886080 16777215 16777215 16777215 3137339392 3137339392 16777215 16777215 16777215 50331648 134217728 3271557120 2650800128 3741319168 3472883712 3674210304 2734686208 16777215 16777215 1392508928 2248146944 3338665984 2231369728 16777215 16777215 134217728 2634022912 3640655872 2952790016 3137339392 2181038080 3489660928 3204448256 2365587456 587202560 3187671040 251658240 218103808 3019898880 637534208 16777215 16777215 16777215 822083584 1828716544 2315255808 2298478592 2415919104 184549376 16777215 520093696 905969664 16777215 16777215 201326592 268435456 16777215 16777215 16777215 16777215 16777215 16777215 67108864 83886080 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: (0@0))! !

FormCache subclass: #ODEqualIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ODEqualIcon classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 18:30'!
defaultFormThatCached
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 83886080 838860800 117440512 16777215 16777215 16777215 16777215 16777215 83886080 838860800 117440512 16777215 16777215 16777215 16777215 1493172224 3372220416 3355443200 3187671040 16777215 16777215 16777215 16777215 1493172224 3372220416 3355443200 3187671040 16777215 16777215 16777215 2181038080 3808428032 3422552064 1308622848 2835349504 1174405120 16777215 16777215 2181038080 3808428032 3422552064 1308622848 2835349504 1174405120 16777215 117440512 2734686208 2868903936 4026531840 4177526784 2751463424 1644167168 16777215 117440512 2734686208 2868903936 4026531840 4177526784 2751463424 1644167168 16777215 167772160 3170893824 2013265920 4143972352 3841982464 3472883712 1946157056 16777215 167772160 3170893824 2013265920 4143972352 3841982464 3472883712 1946157056 16777215 1073741824 3170893824 2147483648 4043309056 3573547008 3472883712 2063597568 16777215 1073741824 3170893824 2147483648 4043309056 3573547008 3472883712 2063597568 16777215 1207959552 2667577344 2600468480 3909091328 3271557120 2952790016 2566914048 16777215 1207959552 2667577344 2600468480 3909091328 3271557120 2952790016 2566914048 16777215 855638016 2533359616 2768240640 2634022912 3724541952 3019898880 2583691264 16777215 855638016 2533359616 2768240640 2634022912 3724541952 3019898880 2583691264 16777215 973078528 3036676096 2533359616 2080374784 4026531840 3355443200 2566914048 16777215 973078528 3036676096 2533359616 2080374784 4026531840 3355443200 2566914048 16777215 469762048 2717908992 2617245696 1895825408 3875536896 3221225472 1946157056 16777215 469762048 2717908992 2617245696 1895825408 3875536896 3221225472 1946157056 16777215 134217728 2734686208 2868903936 2650800128 3321888768 3036676096 2113929216 16777215 134217728 2734686208 2868903936 2650800128 3321888768 3036676096 2113929216 16777215 16777215 2868903936 1056964608 3053453312 3154116608 2701131776 1778384896 16777215 16777215 2868903936 1056964608 3053453312 3154116608 2701131776 1778384896 16777215 16777215 1879048192 1795162112 654311424 2533359616 2936012800 318767104 16777215 16777215 1879048192 1795162112 654311424 2533359616 2936012800 318767104 16777215 16777215 33554432 1728053248 3003121664 2667577344 268435456 16777215 16777215 16777215 33554432 1728053248 3003121664 2667577344 268435456 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: (0@0)).! !

FormCache subclass: #ODIdenticalIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ODIdenticalIcon classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 18:30'!
defaultFormThatCached
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 83886080 838860800 117440512 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1493172224 3372220416 3355443200 3187671040 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2181038080 3808428032 3422552064 1308622848 2835349504 1174405120 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 117440512 2734686208 2868903936 4026531840 4177526784 2751463424 1644167168 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 167772160 3170893824 2013265920 4143972352 3841982464 3472883712 1946157056 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1073741824 3170893824 2147483648 4043309056 3573547008 3472883712 2063597568 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1207959552 2667577344 2600468480 3909091328 3271557120 2952790016 2566914048 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 855638016 2533359616 2768240640 2634022912 3724541952 3019898880 2583691264 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 973078528 3036676096 2533359616 2080374784 4026531840 3355443200 2566914048 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 469762048 2717908992 2617245696 1895825408 3875536896 3221225472 1946157056 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 134217728 2734686208 2868903936 2650800128 3321888768 3036676096 2113929216 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2868903936 1056964608 3053453312 3154116608 2701131776 1778384896 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1879048192 1795162112 654311424 2533359616 2936012800 318767104 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 33554432 1728053248 3003121664 2667577344 268435456 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215)
	offset: (0@0))! !

FormCache subclass: #ODLeftMissingIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ODLeftMissingIcon classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 18:30'!
defaultFormThatCached
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 67108864 184549376 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 536870912 1526726656 16777215 520093696 1493172224 184549376 16777215 16777215 16777215 16777215 335544320 335544320 16777215 16777215 16777215 16777215 788529152 2432696320 16777215 167772160 1610612736 2499805184 402653184 16777215 16777215 318767104 3506438144 3439329280 2902458368 83886080 16777215 16777215 1040187392 2684354560 16777215 16777215 16777215 117440512 150994944 16777215 16777215 2214592512 3489660928 771751936 3321888768 1157627904 16777215 16777215 469762048 855638016 16777215 16777215 16777215 16777215 16777215 16777215 16777216 3204448256 2969567232 2332033024 3523215360 2550136832 16777215 16777215 67108864 167772160 16777215 16777215 16777215 184549376 150994944 16777215 16777215 2785017856 2013265920 3070230528 3539992576 2399141888 16777215 16777215 738197504 1929379840 16777215 16777215 16777215 1157627904 1996488704 16777215 16777215 2298478592 2432696320 3221225472 2499805184 2013265920 16777215 16777215 905969664 2483027968 16777215 16777215 16777215 1728053248 2785017856 16777215 16777215 2231369728 2801795072 2986344448 2181038080 2466250752 16777215 16777215 1157627904 1258291200 16777215 16777215 16777215 1174405120 1560281088 16777215 16777215 2818572288 3288334336 3573547008 3690987520 2634022912 16777215 16777215 754974720 687865856 16777215 16777215 16777215 100663296 100663296 16777215 16777215 3120562176 3741319168 4060086272 3858759680 2583691264 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 2432696320 3758096384 4110417920 3741319168 2717908992 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777216 3271557120 3892314112 3774873600 3338665984 2667577344 16777215 16777215 16777215 184549376 16777215 16777215 16777215 83886080 16777216 16777215 16777215 2902458368 1224736768 1979711488 3288334336 1426063360 16777215 16777215 16777215 1476395008 1962934272 16777215 16777215 1962934272 872415232 16777215 16777215 2415919104 973078528 1744830464 2348810240 536870912 16777215 16777215 16777215 50331648 1996488704 587202560 16777215 3187671040 251658240 16777215 16777215 1711276032 3271557120 2734686208 2130706432 16777215 16777215 16777215 16777215 16777215 16777215 16777215 268435456 1543503872 16777215 16777215 16777215 50331648 1744830464 2332033024 50331648 16777215 16777215)
	offset: (0@0)).! !

FormCache subclass: #ODRightMissingIcon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ODRightMissingIcon classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/31/2012 18:30'!
defaultFormThatCached
^(Form
	extent: (16@16)
	depth: 32
	fromArray: #( 16777215 16777215 16777215 33554432 16777215 16777215 16777215 16777215 16777215 16777215 16777215 922746880 1795162112 167772160 16777215 16777215 16777215 16777215 218103808 2734686208 3238002688 721420288 16777215 16777215 16777215 16777215 16777215 335544320 2046820352 939524096 16777215 16777215 16777215 16777215 1090519040 3238002688 2701131776 3271557120 335544320 16777215 16777215 16777215 184549376 16777215 16777215 16777215 16777215 16777215 16777215 16777215 1174405120 3992977408 3305111552 3254779904 1526726656 16777215 16777215 16777215 1761607680 134217728 16777215 16777215 83886080 50331648 16777215 16777215 2415919104 4110417920 3456106496 3187671040 2667577344 16777215 16777215 16777215 1409286144 50331648 16777215 16777215 1258291200 1090519040 16777215 16777215 3388997632 3976200192 3623878656 3305111552 2902458368 16777215 16777215 16777215 570425344 989855744 16777215 16777215 1459617792 1660944384 16777215 16777215 3523215360 3590324224 3657433088 3791650816 2785017856 16777216 16777215 16777215 939524096 1744830464 16777215 16777215 150994944 285212672 16777215 16777215 3288334336 3338665984 3607101440 3909091328 2801795072 16777215 16777215 16777215 503316480 1090519040 16777215 16777215 16777215 16777215 16777215 16777215 3003121664 3573547008 3791650816 3808428032 2919235584 16777215 16777215 16777215 16777216 150994944 16777215 16777215 16777215 16777215 16777215 16777216 2902458368 3388997632 3992977408 3137339392 3305111552 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777215 16777216 16777215 285212672 2785017856 3204448256 4110417920 2617245696 3556769792 16777215 16777215 16777215 201326592 369098752 16777215 16777215 503316480 989855744 16777215 335544320 2248146944 3992977408 4177526784 3254779904 3523215360 134217728 16777215 16777215 704643072 1342177280 16777215 16777215 855638016 1996488704 16777215 67108864 251658240 4060086272 3976200192 1577058304 3087007744 83886080 16777215 16777215 335544320 771751936 16777215 16777215 469762048 1140850688 16777215 16777215 16777215 3791650816 3321888768 3019898880 503316480 16777215 16777215 16777215 16777215 16777215 16777215 16777215 335544320 16777215 16777215 16777215 16777215 2785017856 2432696320 452984832 16777215 16777215 16777215 16777215 16777216 704643072 1325400064 150994944 318767104 16777215 16777215 16777215 16777215 385875968 16777216 33554432 16777215 16777215 16777215 16777215 16777215 520093696 1291845632 184549376 16777215 16777215)
	offset: (0@0)).! !

Object subclass: #JSItem
	instanceVariableNames: 'leftSideObject rightSideObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

JSItem subclass: #JSInnerWithBlock
	instanceVariableNames: 'comparison diffKey'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

JSInnerWithBlock subclass: #JSInnerDiffableItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!JSInnerDiffableItem methodsFor: 'testing' stamp: 'HwaJong 12/26/2012 21:37'!
canOpenInnerDifference
	^self diffItemType = #different! !

!JSInnerWithBlock methodsFor: 'testing' stamp: 'HwaJong 12/26/2012 22:00'!
canOpenInnerDifferenceAtKey: aByteString 
	^false! !

!JSInnerWithBlock methodsFor: 'testing' stamp: 'HwaJong 12/26/2012 22:00'!
canOpenLeftInspector
	^true! !

!JSInnerWithBlock methodsFor: 'testing' stamp: 'HwaJong 12/26/2012 22:00'!
canOpenRightInspector
	^true! !

!JSInnerWithBlock methodsFor: 'accessing' stamp: 'HwaJong 12/26/2012 22:04'!
comparison: aBlockClosure 
	comparison := aBlockClosure ! !

!JSInnerWithBlock methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 22:04'!
diffItemType
	| v1 v2 |
	v1 := comparison value: leftSideObject.
	v2 := comparison value: rightSideObject.
	v1 == v2 ifTrue: [^#identical].
	v1 = v2 ifTrue: [^#equal].
	^#different! !

!JSInnerWithBlock methodsFor: 'accessing' stamp: 'HwaJong 12/26/2012 22:07'!
diffKey
	^diffKey! !

!JSInnerWithBlock methodsFor: 'accessing' stamp: 'HwaJong 12/26/2012 22:08'!
diffKey: aString
	diffKey := aString! !

!JSInnerWithBlock methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 22:01'!
leftSideObjectEvaluated
	^comparison value: leftSideObject ! !

!JSInnerWithBlock methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 22:02'!
leftSideObjectEvaluatedString
	^self leftSideObjectEvaluated printString ! !

!JSInnerWithBlock methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 22:01'!
rightSideObjectEvaluated
	^comparison value: rightSideObject! !

!JSInnerWithBlock methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 22:03'!
rightSideObjectEvaluatedString
	^self rightSideObjectEvaluated printString! !

JSInnerWithBlock subclass: #JSNotInnerDifferableItem
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!JSNotInnerDifferableItem methodsFor: 'testing' stamp: 'HwaJong 12/26/2012 20:33'!
canOpenInnerDifference
	^false! !

!JSItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 11:45'!
canOpenInnerDifferenceLiteralForm
	^{self diffKey. self canOpenInnerDifference}! !

!JSItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 11:43'!
canOpenInspectorLiteralForm
	^{self diffKey. self canOpenLeftInspector. self canOpenRightInspector}! !

!JSItem methodsFor: 'accessing' stamp: 'HwaJong 12/26/2012 21:57'!
leftSideObject: anObject
	leftSideObject := anObject! !

!JSItem methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 22:07'!
literalForm
	^{self diffItemType. self diffKey. self leftSideObjectEvaluatedString. self rightSideObjectEvaluatedString}! !

!JSItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 12:10'!
objectsLiteralForm
	^{self diffKey. [self leftSideObjectEvaluated] on: Error do: [:e| nil]. [self rightSideObjectEvaluated] on: Error do: [:e| nil]}! !

!JSItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 22:02'!
openInnerDifference
	^DiffSheet new 
		leftSideObject: self leftSideObjectEvaluated;
		rightSideObject: self rightSideObjectEvaluated! !

!JSItem methodsFor: 'accessing' stamp: 'HwaJong 12/26/2012 21:57'!
rightSideObject: anObject
	 rightSideObject := anObject
	! !

!JSItem methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 00:51'!
shouldBeShownOnDiffOnlyList
	^(self diffItemType = #identical or: [self diffItemType = #equal] ) not! !

JSItem subclass: #JSItemWithKey
	instanceVariableNames: 'key'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!JSItemWithKey methodsFor: 'testing' stamp: 'HwaJong 12/26/2012 21:28'!
canOpenInnerDifference
	^self diffItemType = #different! !

!JSItemWithKey methodsFor: 'testing' stamp: 'HwaJong 12/26/2012 21:22'!
canOpenInnerDifferenceAtKey: aByteString 
	^key = aByteString and: [self canOpenLeftInspector and: [self canOpenRightInspector and: [self diffItemType = #different]]]! !

!JSItemWithKey methodsFor: 'testing' stamp: 'HwaJong 12/26/2012 21:30'!
canOpenLeftInspector
	^leftSideObject objectDiffHasKey: key! !

!JSItemWithKey methodsFor: 'testing' stamp: 'HwaJong 12/26/2012 20:22'!
canOpenRightInspector
	^rightSideObject objectDiffHasKey: key! !

!JSItemWithKey methodsFor: 'accessing' stamp: 'HwaJong 12/26/2012 20:21'!
comparison: aSymbol 
	key := aSymbol ! !

!JSItemWithKey methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 20:57'!
diffItemType
	|v1 v2|
	(leftSideObject objectDiffHasKey: key) ifFalse: [^#leftMissing].
	(rightSideObject objectDiffHasKey: key) ifFalse: [^#rightMissing].
	v1 := self leftSideObjectEvaluated.
	v2 := self rightSideObjectEvaluated. 
	
	v1 == v2 ifTrue: [^#identical].
	v1 = v2 ifTrue: [^#equal].
	^#different.! !

!JSItemWithKey methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 22:10'!
diffKey
	^key asString! !

!JSItemWithKey methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 20:45'!
leftSideObjectEvaluated
	^leftSideObject objectDiffValueAt: key! !

!JSItemWithKey methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 21:00'!
leftSideObjectEvaluatedString
	^(leftSideObject objectDiffHasKey: key)
		ifTrue: [self leftSideObjectEvaluated printString]
		ifFalse: ['']
		! !

!JSItemWithKey methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 20:46'!
rightSideObjectEvaluated
	^rightSideObject objectDiffValueAt: key! !

!JSItemWithKey methodsFor: 'self evaluating' stamp: 'HwaJong 12/26/2012 21:04'!
rightSideObjectEvaluatedString
	^(rightSideObject objectDiffHasKey: key)
		ifTrue: [self rightSideObjectEvaluated printString]
		ifFalse: ['']! !

Object subclass: #KSListItem
	instanceVariableNames: 'diffSheet index'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff'!

!KSListItem classSide methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 12:08'!
diffSheet: aDiffSheet index: aSmallInteger 
^self new
	diffSheet: aDiffSheet;
	index: aSmallInteger! !

!KSListItem methodsFor: 'item text' stamp: 'HwaJong 10/31/2012 12:27'!
balloonText
^String streamContents: [:stream| 
	stream nextPutAll: self diffKey.
	stream nextPut: $:.
	stream cr;tab.
	stream nextPutAll: self diffLeftSidePrint.
	stream cr;tab.
	stream nextPutAll: self diffRightSidePrint].! !

!KSListItem methodsFor: 'testing' stamp: 'HwaJong 10/31/2012 12:14'!
canOpenInnerDifference
^diffSheet canOpenInnerDifferenceAtKeyIndex: index! !

!KSListItem methodsFor: 'testing' stamp: 'HwaJong 10/31/2012 19:27'!
canOpenLeftInspector
^diffSheet canOpenLeftInspectorAtRowIndex: index! !

!KSListItem methodsFor: 'testing' stamp: 'HwaJong 10/31/2012 21:26'!
canOpenRightInspector
^diffSheet canOpenRightInspectorAtRowIndex: index! !

!KSListItem methodsFor: 'list view protocol' stamp: 'HwaJong 12/26/2012 16:01'!
diffItemType
^diffSheet comparisonResult diffTypeAtRow: index.! !

!KSListItem methodsFor: 'list view protocol' stamp: 'HwaJong 12/26/2012 21:02'!
diffKey
^(diffSheet comparisonList at: index) diffKey! !

!KSListItem methodsFor: 'list view protocol' stamp: 'HwaJong 12/26/2012 20:59'!
diffLeftSidePrint
^(diffSheet comparisonList at: index) leftSideObjectEvaluatedString.! !

!KSListItem methodsFor: 'list view protocol' stamp: 'HwaJong 12/26/2012 21:03'!
diffRightSidePrint
^(diffSheet comparisonList at: index) rightSideObjectEvaluatedString! !

!KSListItem methodsFor: 'accessing' stamp: 'HwaJong 10/30/2012 12:08'!
diffSheet: aDiffSheet 
diffSheet := aDiffSheet ! !

!KSListItem methodsFor: 'controlling' stamp: 'HwaJong 12/26/2012 16:01'!
ifIdentical: i ifEqual: e ifDifferent: d ifLeftMissing: l ifRightMissing: r 
^((Dictionary new
	at: #different put: d;
	at: #identical put: i;
	at: #equal put: e;
	at: #leftMissing put: l;
	at: #rightMissing put: r;
	yourself) 
		at: (diffSheet diffTypeAtRow: index)) value.
! !

!KSListItem methodsFor: 'accessing' stamp: 'HwaJong 10/30/2012 12:08'!
index: aSmallInteger 
index := aSmallInteger ! !

!KSListItem methodsFor: 'accessing' stamp: 'HwaJong 10/31/2012 11:45'!
innerDifference
^diffSheet openInnerDifferenceAtKeyIndex: index! !

!KSListItem methodsFor: 'actions' stamp: 'HwaJong 10/31/2012 21:30'!
inspectLeft
(diffSheet leftSideObjectOfListItemAtRow: index) inspect.! !

!KSListItem methodsFor: 'actions' stamp: 'HwaJong 10/31/2012 21:32'!
inspectRight
(diffSheet rightSideObjectOfListItemAtRow: index) inspect.! !

!KSListItem methodsFor: 'item text' stamp: 'HwaJong 10/30/2012 12:35'!
oneColumnPrintString
^String streamContents: [:stream| 
	stream nextPutAll: self diffKey.
	stream nextPut: $:.
	stream space.
	stream nextPutAll: self diffLeftSidePrint.
	stream nextPutAll: ' vs '.
	stream nextPutAll: self diffRightSidePrint].! !

Object subclass: #ODAccess
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet'!

Object subclass: #ODSheet
	instanceVariableNames: 'objects accesses'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet'!

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
accesses
	^ accesses! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
accesses: anArray
	accesses := anArray
! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
objects
	^ objects! !

!ODSheet methodsFor: 'accessing' stamp: 'HwaJong 10/13/2012 14:19'!
objects: anArray
	objects := anArray
! !

!ODSheet methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 14:25'!
valueOfObjectAt: objectIndex byAccessAt: accessIndex
|object access|
object := objects at: objectIndex.
access := accesses at: accessIndex.
^[access value: object] on: Error do: [:ex| ex]
! !

Object subclass: #ODWorkspace
	instanceVariableNames: 'sheet cellExtent contents win'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-Sheet-GUI'!

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 18:19'!
cellMorphAtRow: rowIndex atColumn: colIndex
|cellObject morph|
cellObject := 
rowIndex = 0
	ifTrue: 
		[colIndex = 0
			ifTrue: ['objects'] 
			ifFalse: [sheet accesses at: colIndex]]
	ifFalse: 
		[colIndex = 0
			ifTrue: [sheet objects at: rowIndex]
			ifFalse: [sheet valueOfObjectAt: rowIndex byAccessAt: colIndex]].
morph := cellObject printString asMorph.
morph extent: cellExtent.
^morph! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 18:53'!
construct

self makeSheet.

cellExtent := 200@40.

contents := 
UITheme builder newColumn: 
	(Array streamContents: 
		[:rowStream|	
		0 to: sheet objects size do: 
			[:objectIndex|
			rowStream nextPut: 
				(UITheme builder newRow: 
					(Array streamContents: 
						[:stream|
						0 to: sheet accesses size do: 
							[:accessIndex|
							stream nextPut: (self cellMorphAtRow: objectIndex  atColumn: accessIndex)
							]
						])).
			]
]).! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/13/2012 15:24'!
makeSheet
sheet := ODSheet new.
sheet objects: {'hello'. 19. World}.
sheet accesses: {[:o| o sizeInMemory]. [:o| o className]. [:o| o even]}.
! !

!ODWorkspace methodsFor: 'as yet unclassified' stamp: 'HwaJong 10/30/2012 02:48'!
openWindow
win := contents openInWindowLabeled: 'SHEET'.! !

!Object methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/3/2012 10:48'!
diff: anObject 
|obj1 obj2 pr|
obj1 := self.
obj2 := anObject.

pr:= [:obj| obj className, String cr, (obj longPrintStringLimitedTo: 20000)].
(DiffMorph new from: (pr value:obj1) to: (pr value:obj2)) openInWindowLabeled: obj1 printString, ' vs ', obj2 printString.
! !

!Object methodsFor: '*ObjectDiff' stamp: 'HwaJong 12/27/2012 11:18'!
diffyDiff: anObject
|d|
d := DiffSheet new.
d leftSideObject: self.
d rightSideObject: anObject.
(ObjectDiffGUI on: d) open.! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 12/27/2012 13:33'!
isCollectionToObjectDiff
	^self isCollection! !

!Object methodsFor: '*ObjectDiff' stamp: 'HwaJong 10/28/2012 21:08'!
listItemText
^self printString! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/28/2012 02:29'!
objectDiffHasKey: anObject
^self objectDiffKeys includes: anObject ! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/31/2012 00:35'!
objectDiffKeys
^self class allInstVarNames.! !

!Object methodsFor: '*ObjectDiff-System' stamp: 'HwaJong 10/31/2012 00:36'!
objectDiffValueAt: aString 
^self instVarAt: (self class allInstVarNames indexOf: aString)! !

Object subclass: #ObjectDiffGUI
	instanceVariableNames: 'diffSheet diffListSelection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ObjectDiff-GUI'!

!ObjectDiffGUI classSide methodsFor: 'instance creation' stamp: 'HwaJong 10/28/2012 19:41'!
on: aDiffSheet
^self new
	model: aDiffSheet! !

!ObjectDiffGUI methodsFor: 'menu & action' stamp: 'HwaJong 11/22/2012 09:57'!
addModelItemsToWindowMenu: aMenu

	super addModelItemsToWindowMenu: aMenu.
	aMenu addLine.
	aMenu add: 'recompare' target: self action: #windowMenuRecompare! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/31/2012 12:25'!
balloonTextForNode: aPluggableTreeItemNode 
^aPluggableTreeItemNode item balloonText.! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 12/27/2012 11:30'!
diffDetailListTreeItems
^(diffSheet isNil
	ifTrue: [1 to: 5]
	ifFalse: [diffSheet listItems]) collect: [:each| PluggableTreeItemNode with: each model: self ]! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 19:38'!
diffListSelection
^diffListSelection isNil
	ifTrue: [0]
	ifFalse: [diffListSelection item].! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 19:38'!
diffListSelection: aPluggableTreeItemNode 
diffListSelection := aPluggableTreeItemNode.
self changed: #diffListSelection! !

!ObjectDiffGUI methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 18:27'!
filterDropList
	^{'all'. 'different only'} collect: #asMorph! !

!ObjectDiffGUI methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/26/2012 18:39'!
filterIndex
	^diffSheet
		ifShowAll: [1]
		ifShowDifferentOnly: [2]! !

!ObjectDiffGUI methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/27/2012 11:24'!
filterIndex: anInteger 
	anInteger = 1
		ifTrue: [diffSheet beShowAll.
			^self changed: #diffDetailListTreeItems].
	anInteger = 2
		ifTrue: [diffSheet beShowDifferentOnly.
			^self changed: #diffDetailListTreeItems].
	self error: 'unknown choice'! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/28/2012 19:35'!
hasNodeContents: object
^false! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/31/2012 18:29'!
iconOfNode: aPluggableTreeItemNode 
^aPluggableTreeItemNode item
	ifIdentical: [ODIdenticalIcon formThatCached] ifEqual: [ODEqualIcon formThatCached] ifDifferent: [ODDifferentIcon formThatCached] ifLeftMissing: [ODLeftMissingIcon formThatCached] ifRightMissing: [ODRightMissingIcon formThatCached]
! !

!ObjectDiffGUI methodsFor: 'menu & action' stamp: 'HwaJong 10/31/2012 11:54'!
innerDiff
(ObjectDiffGUI on: (diffListSelection item innerDifference)) open.! !

!ObjectDiffGUI methodsFor: 'menu & action' stamp: 'HwaJong 10/31/2012 21:30'!
inspectLeft
diffListSelection item inspectLeft! !

!ObjectDiffGUI methodsFor: 'menu & action' stamp: 'HwaJong 10/31/2012 21:31'!
inspectRight
diffListSelection item inspectRight! !

!ObjectDiffGUI methodsFor: 'accessing' stamp: 'HwaJong 10/28/2012 19:43'!
model: aDiffSheet 
diffSheet := aDiffSheet! !

!ObjectDiffGUI methodsFor: 'display' stamp: 'HwaJong 12/26/2012 18:25'!
open
|builder dropList list window|
builder := UITheme builder.

dropList := builder newMorphDropListFor: self list: #filterDropList getSelected: #filterIndex setSelected: #filterIndex: help: 'filter the list below'.

list := builder newTreeFor: self list: #diffDetailListTreeItems selected: #diffListSelection changeSelected: #diffListSelection:.
list getMenuSelector: #popUpMenu:.
window := (builder newColumn: {dropList. list}) openInWindowLabeled: 'Diffy Diffy Diff Diff'.
window extent: 320@460.
window model: self.! !

!ObjectDiffGUI methodsFor: 'menu & action' stamp: 'HwaJong 10/31/2012 21:31'!
popUpMenu: aMenuMorph 
diffListSelection item canOpenInnerDifference
	ifTrue: [aMenuMorph add: 'inner diff' action: #innerDiff].
diffListSelection item canOpenLeftInspector
	ifTrue: [aMenuMorph add: 'inspect left' action: #inspectLeft].
diffListSelection item canOpenRightInspector
	ifTrue: [aMenuMorph add: 'inspect right' action: #inspectRight].
^aMenuMorph! !

!ObjectDiffGUI methodsFor: 'list' stamp: 'HwaJong 10/30/2012 12:32'!
printNode: aPluggableTreeItemNode 
^aPluggableTreeItemNode item oneColumnPrintString.! !

!ObjectDiffGUI methodsFor: 'menu & action' stamp: 'HwaJong 11/22/2012 10:04'!
windowMenuRecompare
diffSheet recompare. 
self changed: #diffDetailListTreeItems.! !
